;;
;; Copyright (c) 2005, Gigamonkeys Consulting All rights reserved.
;;

(in-package :com.gigamonkeys.markup)

(defparameter *paragraph-tags* '(:paragraph :modeline :item :href :text :td :p :blockquote :example)
  "Tags that should be parsed as paragraphs when they occur at the top level.")

(defparameter *subdocument-tags* '(:subdoc :note :sidebar :bullets :table :tr :link)
  "Tags that should be parsed as documents that can contain paragraphs.")

(defparameter *list-items-tags* '(:numbered-list-item :bulleted-list-item)
  "Tags that should be combined into a list.")

(defparameter *indented-paragraph-tags* '((2 . :blockquote) (4 . :example))
  "Mapping from indentation levels to tag names.")

(defparameter *outline-tag-base* "H"
  "Prefix used to create tag names for Emacs outline header paragraphs.")

(defparameter *invisible* '(:modeline :foo)
  "Tags that are not included in the output of RENDER.")

(defparameter *invisible-with-dot* '(:h1 :h2 :h3)
  "Tags that are not included in the output of RENDER when their
text starts with a dot. Used mostly to allow headers in outline
mode to keep Emacs happy without having to have a heading in the
output.")

(defparameter *verbatim-elements* '(:example :code)
  "Tags (before translation) that should not have character translation done.")

(defparameter *copyright* (format nil "~d, Peter Seibel" (with-time (year) (get-universal-time) year))
  "Included in copyright notice included in footer of PDF output.")

(defparameter *tab-width* 8
  "Number of spaces to read instead of a tab character in leading
  indentation. Set to NIL to read tabs as tabs.")

(defvar *style-sheet-name* nil
  "If non-nil, this is used to specify the name of the style sheet in generated documents.") 

(defvar *custom-headers* nil
  "If non-nil, this will be inserted in the headers of the generated document. It should be an sexp based representation of the headers.")
