((:P "In summary, the two common problems to watch out for when using
destructive functions are:")
 (:NUMBERED
  (:ITEM
   (:P "Forgetting to store the result back. Even though the list is
modified in place, it is still necessary to store the result of the
function back into the original location, e.g.,")
   (:EXAMPLE "(setq foo (delete 'x foo))")
   (:P
    "If the original list was stored in multiple places, you may need to
store it back in all of them, e.g.")
   (:EXAMPLE "(setq bar foo)
...
(setq foo (delete 'x foo))
(setq bar foo)"))
  (:ITEM
   (:P "Sharing structure that gets modified. If it is important to
preserve the shared structure, then you should either use a
nondestructive operation or copy the structure first using COPY-LIST
or COPY-TREE.")
   (:EXAMPLE "(setq bar (cdr foo))
...
(setq foo (sort foo #'<))
;;; now it's not safe to use BAR")))
 (:P
  "Note that even nondestructive functions, such as REMOVE, and UNION,
can return a result which shares structure with an argument.
Nondestructive functions don't necessarily copy their arguments; they
just don't modify them."))